-- /* $Id: pgrpm.sql.in,v 1.4 2005/03/23 23:43:44 nanardon Exp $

--
-- Return 1 if arg1 > arg2, 0 if ==, -1 if arg1 < arg2
--
CREATE
 or REPLACE 
    FUNCTION rpmvercmp(TEXT, TEXT) RETURNS integer as
    '$libdir/pgrpm', 'pgrpmvercmp' LANGUAGE C STRICT;

--
-- Return TRUE if a == b
--
CREATE 
 or REPLACE 
     FUNCTION rpmvercmpeq(TEXT, TEXT) RETURNS boolean as
    '$libdir/pgrpm', 'pgrpmvercmpeq' LANGUAGE C STRICT;

--
-- Return TRUE if a != b
--
CREATE 
 or REPLACE
    FUNCTION rpmvercmpne(TEXT, TEXT) RETURNS boolean as
    '$libdir/pgrpm', 'pgrpmvercmpne' LANGUAGE C STRICT;

--
-- Return TRUE is a > b
--
CREATE
 or REPLACE 
    FUNCTION rpmvercmpgt(TEXT, TEXT) RETURNS boolean as
    '$libdir/pgrpm', 'pgrpmvercmpgt' LANGUAGE C STRICT;

--
-- Return TRUE is a >= b
--
CREATE 
 or REPLACE 
    FUNCTION rpmvercmpget(TEXT, TEXT) RETURNS boolean as
    '$libdir/pgrpm', 'pgrpmvercmpget' LANGUAGE C STRICT;

--
-- Return TRUE if a < b
--
CREATE 
 or REPLACE 
    FUNCTION rpmvercmplt(TEXT, TEXT) RETURNS boolean as
    '$libdir/pgrpm', 'pgrpmvercmplt' LANGUAGE C STRICT;

--
-- Return TRUE if a <= b
--
CREATE 
 or REPLACE 
    FUNCTION rpmvercmplet(TEXT, TEXT) RETURNS boolean as
    '$libdir/pgrpm', 'pgrpmvercmplet' LANGUAGE C STRICT;


 DROP OPERATOR == (text, text);
CREATE OPERATOR == (
    leftarg = text,
    rightarg = text,
    procedure = rpmvercmpeq,
    commutator = ==,
    negator = <=>
);

 DROP OPERATOR <=> (text, text);
CREATE OPERATOR <=> (
    leftarg = text,
    rightarg = text,
    procedure = rpmvercmpne,
    commutator = <=>,
    negator = ==
);

 DROP OPERATOR << (text, text);
CREATE OPERATOR << (
    leftarg = text,
    rightarg = text,
    procedure = rpmvercmplt,
    commutator = >>,
    negator = >>=
);

 DROP OPERATOR <<= (text, text);
CREATE OPERATOR <<= (
    leftarg = text,
    rightarg = text,
    procedure = rpmvercmplet,
    commutator = >>=,
    negator = >>
);


 DROP OPERATOR >> (text, text);
CREATE OPERATOR >> (
    leftarg = text,
    rightarg = text,
    procedure = rpmvercmpgt,
    commutator = <<,
    negator = <<=
);

 DROP OPERATOR >>= (text, text);
CREATE OPERATOR >>= (
    leftarg = text,
    rightarg = text,
    procedure = rpmvercmpget,
    commutator = <<=,
    negator = <<
);

